/* Original code and idea (C) Antonio Jos Villena Godoy, updates and modifications (C) Carlos Snchez */

/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
*/


/*
 * This class parses command line and stores options into it *
 */
public class commandLine {

	public String fileName = "";
	public boolean isMono =  false;
	public boolean isTC2048 = false;
	public boolean useScreen = false;
	public boolean isSyntax = false;
	public int leadToneLength = 3000;
	public int HIBitValue = 17;
	public int LOBitValue = 7;
		
	
	public commandLine (String[] args)
	{
		
		try
		{
		for ( int i = 0 ; i < args.length ; i++ )
			if (args[i].equals("-t")) isTC2048 =  true;
			else if (args[i].equals("-s")) useScreen =  true; 
			else if (args[i].equals("-m")) isMono =  true; 
			else if (args[i].equals("-h")) isSyntax=  true;
			else if (args[i].startsWith("-l")) leadToneLength = Integer.parseInt(args[i].substring(2,args[i].length()));	
			else if (args[i].startsWith("-lb")) LOBitValue = Integer.parseInt(args[i].substring(2,args[i].length()));	
			else if (args[i].startsWith("-hb")) HIBitValue = Integer.parseInt(args[i].substring(2,args[i].length()));	
			else if (fileName.length() == 0) fileName += args[i];
			else isSyntax = true;
		}
		catch (NumberFormatException e)
		{
			isSyntax = true;
		}
	}
	
	/*
	 * Shows command line syntax
	 */
	public void showSyntax() {
		System.out.println("Syntax: sna2wav [-t] [-m] [-s] [-l<n>] [-lb<n>] [-hb<n>] [-h] <filename>\n");
		System.out.println("-t Generate wav for Timex TC2048");
		System.out.println("-m Generate mono wav file");
		System.out.println("-s Use screen to store ultraload code");
		System.out.println("-l<n> Set n as length of lead tone (defaults to 3000)");
		System.out.println("-hb<n> Set n as value for '1' on standar loader (defaults to 17)");
		System.out.println("-lb<n> Set n as value for '0' on standar loader (defaults to 7)");
		System.out.println("-h Show this message");
		System.out.println("\nSample: sna2wav -m -l4500 -lb8 -hb20");
		System.exit(0);
	}

}
